VERSION 5.00
Begin VB.UserControl X3Label 
   BackStyle       =   0  'Transparent
   ClientHeight    =   330
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3270
   ScaleHeight     =   330
   ScaleWidth      =   3270
   Windowless      =   -1  'True
End
Attribute VB_Name = "X3Label"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private m_oRTFPrinter As X3RTFPrinter
Private m_szCaption   As String

Public Property Let Caption(ByVal szCaption As String)
    Dim lW As Long, lH As Long
    
    m_szCaption = szCaption
    lW = (UserControl.Width \ Screen.TwipsPerPixelX)
    Call m_oRTFPrinter.sizeText(UserControl.hdc, lW, lH)
    Call m_oRTFPrinter.createImage(lW, lH)
End Property
Public Property Get Caption() As String
    Caption = m_szCaption
End Property

Private Sub UserControl_Initialize()
    Set m_oRTFPrinter = New X3RTFPrinter
    Caption = "Xiphias3"
End Sub

Private Sub UserControl_Paint()
    Call m_oRTFPrinter.getImage().drawIcon(mUtil.getGraphicsContext(UserControl.hdc), 0, 0, , , , , , , , , True)
    Call UserControl.Refresh
End Sub

Private Sub UserControl_Resize()
    Call UserControl_Paint
End Sub

Private Sub UserControl_Show()
    Call UserControl_Paint
End Sub

Private Sub UserControl_Terminate()
    Set m_oRTFPrinter = Nothing
End Sub
