VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "X3TextPrinter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Declare Function GdipResetClip Lib "GdiPlus.dll" (ByVal mGraphics As Long) As GpStatus
Private Declare Function GdipCombineRegionPath Lib "GdiPlus.dll" (ByVal mRegion As Long, ByVal mpath As Long, ByVal mCombineMode As CombineMode) As GpStatus
Private Declare Function GdipSetClipRegion Lib "GdiPlus.dll" (ByVal mGraphics As Long, ByVal mRegion As Long, ByVal mCombineMode As CombineMode) As GpStatus
Private Declare Function GdipCreateRegionRect Lib "GdiPlus.dll" (ByRef mRect As RECTF, ByRef mRegion As Long) As GpStatus
Private Declare Function GdipDeleteRegion Lib "GdiPlus.dll" (ByVal mRegion As Long) As GpStatus
Private Enum CombineMode
    CombineModeReplace = &H0
    CombineModeIntersect = &H1
    CombineModeUnion = &H2
    CombineModeXor = &H3
    CombineModeComplement = &H5
End Enum

Private Declare Function GdipSetPenMode Lib "GdiPlus.dll" (ByVal mPen As Long, ByVal mPenMode As PenAlignment) As GpStatus
Private Declare Function GdipCreatePath Lib "GdiPlus.dll" (ByVal mBrushMode As FillMode, ByRef mpath As Long) As GpStatus
Private Declare Function GdipAddPathString Lib "GdiPlus.dll" (ByVal mpath As Long, ByVal mString As Long, ByVal mLength As Long, ByVal mFamily As Long, ByVal mStyle As Long, ByVal mEmSize As Single, ByRef mLayoutRect As RECTF, ByVal mFormat As Long) As GpStatus
Private Declare Function GdipCreateFontFamilyFromName Lib "GdiPlus.dll" (ByVal mName As Long, ByVal mFontCollection As Long, ByRef mFontFamily As Long) As GpStatus
Private Declare Function GdipDeleteFontFamily Lib "GdiPlus.dll" (ByVal mFontFamily As Long) As GpStatus
Private Declare Function GdipDeletePath Lib "GdiPlus.dll" (ByVal mpath As Long) As GpStatus
Private Declare Function GdipCreatePen1 Lib "GdiPlus.dll" (ByVal mColor As Long, ByVal mWidth As Single, ByVal mUnit As GpUnit, ByRef mPen As Long) As GpStatus
Private Declare Function GdipDeletePen Lib "GdiPlus.dll" (ByVal mPen As Long) As GpStatus
Private Declare Function GdipFillPath Lib "GdiPlus.dll" (ByVal mGraphics As Long, ByVal mBrush As Long, ByVal mpath As Long) As GpStatus
Private Declare Function GdipDrawPath Lib "GdiPlus.dll" (ByVal mGraphics As Long, ByVal mPen As Long, ByVal mpath As Long) As GpStatus
Private Declare Function GdipSetPenLineJoin Lib "GdiPlus.dll" (ByVal mPen As Long, ByVal mLineJoin As LineJoin) As GpStatus
Private Declare Function GdipSetPenStartCap Lib "GdiPlus.dll" (ByVal mPen As Long, ByVal mStartCap As LineCap) As GpStatus
Private Declare Function GdipSetPenEndCap Lib "GdiPlus.dll" (ByVal mPen As Long, ByVal mEndCap As LineCap) As GpStatus
Private Enum LineCap
    LineCapFlat = &H0
    LineCapSquare = &H1
    LineCapRound = &H2
    LineCapTriangle = &H3
    LineCapNoAnchor = &H10
    LineCapSquareAnchor = &H11
    LineCapRoundAnchor = &H12
    LineCapDiamondAnchor = &H13
    LineCapArrowAnchor = &H14
    LineCapCustom = &HFF
    LineCapAnchorMask = &HF0
End Enum
Private Enum LineJoin
    LineJoinMiter = &H0
    LineJoinBevel = &H1
    LineJoinRound = &H2
    LineJoinMiterClipped = &H3
End Enum
Private Enum GpUnit
    UnitWorld = &H0
    UnitDisplay = &H1
    UnitPixel = &H2
    UnitPoint = &H3
    UnitInch = &H4
    UnitDocument = &H5
    UnitMillimeter = &H6
End Enum
Private Enum FillMode
    FillModeAlternate = &H0
    FillModeWinding = &H1
End Enum
Private Enum PenAlignment
    PenAlignmentCenter = &H0
    PenAlignmentInset = &H1
End Enum
Private Enum EFontStyle
    FontStyleRegular = 0
    FontStyleBold = 1
    FontStyleItalic = 2
    FontStyleBoldItalic = 3
    FontStyleUnderline = 4
    FontStyleStrikeout = 8
End Enum

Private Declare Function GdipCreateFontFromLogfontA Lib "GdiPlus.dll" (ByVal mhDC As Long, ByRef mLogfont As LOGFONTA, ByRef mFont As Long) As GpStatus
Private Declare Function GetDeviceCaps Lib "gdi32.dll" (ByVal hdc As Long, ByVal nIndex As Long) As Long
Private Declare Function GdipDeleteFont Lib "GdiPlus.dll" (ByVal mFont As Long) As GpStatus
Private Declare Function GdipDrawString Lib "GdiPlus.dll" (ByVal mGraphics As Long, ByVal mString As Long, ByVal mLength As Long, ByVal mFont As Long, ByRef mLayoutRect As RECTF, ByVal mStringFormat As Long, ByVal mBrush As Long) As GpStatus
Private Declare Function GdipCreateStringFormat Lib "GdiPlus.dll" (ByVal mFormatAttributes As Long, ByVal mLanguage As Integer, ByRef mFormat As Long) As GpStatus
Private Declare Function GdipDeleteStringFormat Lib "GdiPlus.dll" (ByVal mFormat As Long) As GpStatus
Private Declare Function GdipReleaseDC Lib "GdiPlus.dll" (ByVal mGraphics As Long, ByVal mhDC As Long) As GpStatus
Private Declare Function GdipGetDC Lib "GdiPlus.dll" (ByVal mGraphics As Long, ByRef mhDC As Long) As GpStatus
Private Declare Function GdipSetTextRenderingHint Lib "GdiPlus.dll" (ByVal mGraphics As Long, ByVal mMode As TextRenderingHint) As GpStatus
Private Declare Function GdipGetTextRenderingHint Lib "GdiPlus.dll" (ByVal mGraphics As Long, ByRef mMode As TextRenderingHint) As GpStatus
Private Declare Function GdipSetStringFormatAlign Lib "GdiPlus.dll" (ByVal mFormat As Long, ByVal mAlign As Long) As GpStatus
Private Declare Function GdipSetStringFormatFlags Lib "GdiPlus.dll" (ByVal mFormat As Long, ByVal mFlags As Long) As GpStatus
Private Declare Function GdipSetStringFormatLineAlign Lib "GdiPlus.dll" (ByVal mFormat As Long, ByVal mAlign As Long) As GpStatus
Private Declare Function GdipMeasureString Lib "GdiPlus.dll" (ByVal mGraphics As Long, ByVal mString As String, ByVal mLength As Long, ByVal mFont As Long, ByRef mLayoutRect As RECTF, ByVal mStringFormat As Long, ByRef mBoundingBox As RECTF, ByRef mCodepointsFitted As Long, ByRef mLinesFilled As Long) As GpStatus
Private Declare Function GdipCreateSolidFill Lib "GdiPlus.dll" (ByVal mColor As Long, ByRef mBrush As Long) As GpStatus
Private Declare Function GdipDeleteBrush Lib "GdiPlus.dll" (ByVal mBrush As Long) As GpStatus
Private Declare Function MulDiv Lib "kernel32.dll" (ByVal nNumber As Long, ByVal nNumerator As Long, ByVal nDenominator As Long) As Long
Private Declare Function GetDC Lib "user32.dll" (ByVal hWnd As Long) As Long
Private Declare Function ReleaseDC Lib "user32.dll" (ByVal hWnd As Long, ByVal hdc As Long) As Long

Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (ByRef Destination As Any, ByRef Source As Any, ByVal Length As Long)

Private Type RECTF
    Left   As Single
    Top    As Single
    Width  As Single
    Height As Single
End Type

Private Enum TextRenderingHint
    TextRenderingHintSystemDefault = &H0
    TextRenderingHintSingleBitPerPixelGridFit = &H1
    TextRenderingHintSingleBitPerPixel = &H2
    TextRenderingHintAntiAliasGridFit = &H3
    TextRenderingHintAntiAlias = &H4
    TextRenderingHintClearTypeGridFit = &H5
End Enum

Private Enum EHAlignment
    HLeft = &H0
    HCenter = &H1
    HRight = &H2
End Enum

Private Enum EVAlignment
    VTop = &H0
    VCenter = &H1
    VBottom = &H2
End Enum

Private Enum GpStatus
    Ok = &H0
End Enum

Private Const LF_FACESIZE As Long = 32
Private Type LOGFONTA
    lfHeight As Long
    lfWidth As Long
    lfEscapement As Long
    lfOrientation As Long
    lfWeight As Long
    lfItalic As Byte
    lfUnderline As Byte
    lfStrikeOut As Byte
    lfCharSet As Byte
    lfOutPrecision As Byte
    lfClipPrecision As Byte
    lfQuality As Byte
    lfPitchAndFamily As Byte
    lfFaceName(LF_FACESIZE - 1) As Byte
End Type

Private Const FW_MAX    As Long = 1000
Private Const FW_NORMAL As Long = 400
Private Const FW_BOLD   As Long = 700

Public Enum EFontFormatting
    FF_ITALIC = 2
    FF_UNDERLINE = 4
    FF_STRIKETHRU = 8
    FF_BOLD = 16
End Enum

Public Enum ECharset
    ANSI_CHARSET = 0
    DEFAULT_CHARSET = 1
End Enum

Private Const OUT_DEFAULT_PRECIS  As Long = 0
Private Const CLIP_DEFAULT_PRECIS As Long = 0
Private Const PROOF_QUALITY       As Long = 2
Private Const LOGPIXELSY          As Long = 90
Private Const DEFAULT_PITCH       As Long = 0

Private m_hFont           As Long
Private m_rcLayout        As RECTF
Private m_eH              As EHAlignment
Private m_eV              As EVAlignment
Private m_szText          As String
Private m_szFontName      As String
Private m_lFontSize       As Long
Private m_lFontStyle      As Long
Private m_lColShadow      As Long
Private m_nShadowOffX     As Integer
Private m_nShadowOffY     As Integer
Private m_lTxtOutlineCol  As Long
Private m_bOutlineOpacity As Byte
Private m_nOutlineWid     As Integer
Private m_lTextCol        As Long
Private m_szTag           As String

Public Property Get Tag() As String
    Tag = m_szTag
End Property
Public Property Let Tag(ByVal szVal As String)
    m_szTag = szVal
End Property

Private Sub Class_Initialize()
    m_lColShadow = 0
    m_lTxtOutlineCol = 0
    m_lTextCol = &HFF000000
    m_nOutlineWid = 4
    m_bOutlineOpacity = 195
End Sub

Private Sub Class_Terminate()
    Call dispose
End Sub

Public Function dispose()
    If (m_hFont) Then Call GdipDeleteFont(m_hFont)
    m_hFont = 0
    m_szText = vbNullString
End Function

Public Function setLayoutRect(ByVal sX As Single, ByVal sY As Single, ByVal sW As Single, ByVal sH As Single)
    With m_rcLayout
        .Left = sX
        .Top = sY
        .Width = sW
        .Height = sH
    End With
End Function

Public Property Get DestX() As Single
    DestX = m_rcLayout.Left
End Property
Public Property Let DestX(sVal As Single)
    m_rcLayout.Left = sVal
End Property

Public Property Get DestY() As Single
    DestY = m_rcLayout.Top
End Property
Public Property Let DestY(sVal As Single)
    m_rcLayout.Top = sVal
End Property

Public Property Get DestW() As Single
    DestW = m_rcLayout.Width
End Property
Public Property Let DestW(sVal As Single)
    m_rcLayout.Width = sVal
End Property

Public Property Get DestH() As Single
    DestH = m_rcLayout.Height
End Property
Public Property Let DestH(sVal As Single)
    m_rcLayout.Height = sVal
End Property

Public Function adjustRect(ByVal lX As Long, ByVal lY As Long)
    m_rcLayout.Left = (m_rcLayout.Left + lX)
    m_rcLayout.Top = (m_rcLayout.Top + lY)
End Function

'Public Function setAlignment(ByVal eH As EHAlignment, ByVal eV As EVAlignment)
Public Function setAlignment(ByVal EH As Integer, ByVal eV As Integer)
    m_eH = EH
    m_eV = eV
End Function

Public Function setText(ByRef szText As String)
    m_szText = Replace(szText, "\n", vbCrLf)
End Function

Public Function setShadowEffect(Optional ByVal lColShadow As Long = 0, Optional ByVal nShadowOffX As Integer = 2, Optional ByVal nShadowOffY As Integer = 2)
    m_lColShadow = lColShadow
    m_nShadowOffX = nShadowOffX
    m_nShadowOffY = nShadowOffY
End Function

Public Function setOutlineEffect(Optional ByVal lTxtOutlineCol = 0, Optional bOutlineOpacity As Byte = 195, Optional ByVal nOutlineWid As Integer = 5)
    m_lTxtOutlineCol = lTxtOutlineCol
    m_bOutlineOpacity = bOutlineOpacity
    m_nOutlineWid = nOutlineWid
End Function

Public Function getShadowEffect(Optional ByRef lColShadow As Long, Optional ByRef nShadowOffX As Integer, Optional ByRef nShadowOffY As Integer)
    lColShadow = m_lColShadow
    nShadowOffX = m_nShadowOffX
    nShadowOffY = m_nShadowOffY
End Function

Public Function getOutlineEffect(Optional ByRef lColOutline As Long, Optional ByRef bOutlineOpacity As Byte, Optional ByRef nOutlineWid As Integer)
    lColOutline = m_lTxtOutlineCol
    bOutlineOpacity = m_bOutlineOpacity
    nOutlineWid = m_nOutlineWid
End Function

Public Function setTextColor(ByVal lCol32 As Long)
    m_lTextCol = lCol32
End Function

Public Function getTextColor() As Long
    getTextColor = m_lTextCol
End Function

Public Function getText() As String
    getText = m_szText
End Function

'Public Function getAlignment(Optional ByRef eHAlign As EHAlignment, Optional ByRef eVAlign As EVAlignment)
Public Function getAlignment(Optional ByRef eHAlign As Integer, Optional ByRef eVAlign As Integer)
    eHAlign = m_eH
    eVAlign = m_eV
End Function

Public Function getLayoutRect(Optional ByRef lX As Long, Optional ByRef lY As Long, Optional ByRef lW As Long, Optional ByRef lH As Long)
    With m_rcLayout
        lX = .Left
        lY = .Top
        lW = .Width
        lH = .Height
    End With
End Function

Public Function getFontSize() As Long
    getFontSize = m_lFontSize
End Function

Public Function getFontName() As String
    getFontName = m_szFontName
End Function

Public Function getFontFormatting(Optional ByRef bBold As Boolean, Optional ByRef bItalic As Boolean, Optional ByRef bUnderline As Boolean, Optional ByRef bStrikeOut As Boolean)
    bBold = ((m_lFontSize And EFontStyle.FontStyleBold) = EFontStyle.FontStyleBold)
    bItalic = ((m_lFontSize And EFontStyle.FontStyleItalic) = EFontStyle.FontStyleItalic)
    bUnderline = ((m_lFontSize And EFontStyle.FontStyleUnderline) = EFontStyle.FontStyleUnderline)
    bStrikeOut = ((m_lFontSize And EFontStyle.FontStyleStrikeout) = EFontStyle.FontStyleStrikeout)
End Function

Public Function printText(ByVal hGraphics As Long)
    Dim hStringFrmt As Long, eRet As GpStatus, hBrush As Long, ePrevTxtRndrntHnt As TextRenderingHint, hBrushShadow As Long, _
        i As Integer, hPen As Long, hRgn As Long, bR As Byte, bG As Byte, bB As Byte, hPath As Long, hFontFam As Long, lOutlineCol As Long
    
    If (m_szText = "") Then Exit Function
    
    eRet = GdipCreateStringFormat(0, 0, hStringFrmt)
    eRet = GdipSetStringFormatAlign(hStringFrmt, m_eH)
    eRet = GdipSetStringFormatLineAlign(hStringFrmt, m_eV)
    
    If (m_lColShadow) Then      'SHADOW
        Call GdipCreateSolidFill(m_lColShadow, hBrushShadow)
        Call adjustRect(m_nShadowOffX, m_nShadowOffY)
        Call GdipDrawString(hGraphics, StrPtr(m_szText), (-1), m_hFont, m_rcLayout, hStringFrmt, hBrushShadow)
        Call adjustRect(-(m_nShadowOffX), -(m_nShadowOffY))
        Call GdipDeleteBrush(hBrushShadow)
    End If
    
    If (m_lTxtOutlineCol) Then 'OUTLINE
        Call GdipCreateFontFamilyFromName(StrPtr(m_szFontName), 0, hFontFam)
        Call mUtil.splitDWORDEx(m_lTxtOutlineCol, bB, bG, bR, 0)
        Call GdipCreatePath(FillModeWinding, hPath)
        Call GdipAddPathString(hPath, StrPtr(m_szText), (-1), hFontFam, m_lFontStyle, m_lFontSize, m_rcLayout, hStringFrmt)
        Call GdipDeleteFontFamily(hFontFam)
        
        ' Cutout(XOR) text since we're using Center pen mode which means some of the pen
        ' can be drawn inside the text area which will influence actual text color
        eRet = GdipCreateRegionRect(m_rcLayout, hRgn)
        eRet = GdipCombineRegionPath(hRgn, hPath, CombineModeXor)
        eRet = GdipSetClipRegion(hGraphics, hRgn, CombineModeReplace)
        
        lOutlineCol = mUtil.ARGB(m_bOutlineOpacity, bR, bG, bB)
        eRet = GdipCreatePen1(lOutlineCol, m_nOutlineWid, UnitPixel, hPen)
        eRet = GdipSetPenEndCap(hPen, LineCapRound)
        eRet = GdipSetPenStartCap(hPen, LineCapRound)
        eRet = GdipSetPenLineJoin(hPen, LineJoinRound)
        eRet = GdipSetPenMode(hPen, PenAlignmentCenter)
        eRet = GdipDrawPath(hGraphics, hPen, hPath)
        eRet = GdipDeletePen(hPen)
        
        Call GdipResetClip(hGraphics)
        Call GdipDeleteRegion(hRgn)
        
        eRet = GdipCreateSolidFill(m_lTextCol, hBrush)
        eRet = GdipFillPath(hGraphics, hBrush, hPath)
        eRet = GdipDeletePath(hPath)
    Else
        eRet = GdipCreateSolidFill(m_lTextCol, hBrush)
        eRet = GdipDrawString(hGraphics, StrPtr(m_szText), (-1), m_hFont, m_rcLayout, hStringFrmt, hBrush)
    End If
    
    Call GdipDeleteBrush(hBrush)
    Call GdipDeleteStringFormat(hStringFrmt)
End Function

'Public Function setFont(ByRef szName As String, ByVal nSize As Integer, ByRef eFormattingFlags As EFontFormatting, _
                        Optional ByVal lCharSet As Long = ANSI_CHARSET) As Boolean
Public Function setFont(ByRef szName As String, ByVal nSize As Integer, ByRef eFormattingFlags As Integer, Optional ByVal lCharSet As Long = ANSI_CHARSET) As Boolean
    If (m_hFont) Then
        Call GdipDeleteFont(m_hFont)
        m_hFont = 0
    End If
    
    m_hFont = createFont(szName, nSize, eFormattingFlags, , m_lFontSize, lCharSet)
    If (m_hFont) Then
        m_szFontName = szName
        m_lFontStyle = 0
        If (eFormattingFlags And FF_BOLD) Then m_lFontStyle = m_lFontStyle Or EFontStyle.FontStyleBold
        If (eFormattingFlags And FF_ITALIC) Then m_lFontStyle = m_lFontStyle Or EFontStyle.FontStyleItalic
        If (eFormattingFlags And FF_UNDERLINE) Then m_lFontStyle = m_lFontStyle Or EFontStyle.FontStyleUnderline
        If (eFormattingFlags And FF_STRIKETHRU) Then m_lFontStyle = m_lFontStyle Or EFontStyle.FontStyleStrikeout
    End If
    setFont = (m_hFont <> 0)
End Function

Public Function setFontFromStdFont(ByVal oFnt As StdFont) As Boolean
    setFontFromStdFont = setFont(oFnt.Name, oFnt.Size, getFontFlags(oFnt.Bold, oFnt.Italic, oFnt.Underline, oFnt.Strikethrough), oFnt.Charset)
End Function

'Public Function measureString(ByVal hGraphics As Long, ByRef szTxt As String, ByVal oFnt As StdFont, ByVal eHAlign As EHAlignment, ByVal eVAlign As EVAlignment, ByRef lW As Long, ByRef lH As Long)
Public Function measureString(ByVal hGraphics As Long, ByRef szTxt As String, ByVal oFnt As StdFont, ByVal eHAlign As Integer, ByVal eVAlign As Integer, ByRef lW As Long, ByRef lH As Long)
    Dim rcLayout As RECTF, rcBounds As RECTF, eRet As GpStatus, hFont As Long, hStringFormat As Long
    
    With rcLayout
        .Left = 0
        .Top = 0
        .Width = 10000
        .Height = 10000
    End With
    
    hFont = createFont(oFnt.Name, oFnt.Size, getFontFlags(oFnt.Bold, oFnt.Italic, oFnt.Underline, oFnt.Strikethrough), , , oFnt.Charset)
    eRet = GdipCreateStringFormat(0, 0, hStringFormat)
    eRet = GdipSetStringFormatAlign(hStringFormat, eHAlign)
    eRet = GdipSetStringFormatLineAlign(hStringFormat, eVAlign)
    eRet = GdipMeasureString(hGraphics, StrPtr(szTxt), (-1), hFont, rcLayout, hStringFormat, rcBounds, ByVal 0, ByVal 0)
    Call GdipDeleteStringFormat(hStringFormat)
    Call GdipDeleteFont(hFont)
    Debug.Assert (eRet = Ok)
    
    lW = rcBounds.Width
    lH = rcBounds.Height
End Function

Public Function getFontFlags(ByRef bBold As Boolean, ByRef bItalic As Boolean, ByRef bUnderline As Boolean, ByRef bStrikeOut As Boolean)
    Dim eFlags As EFontFormatting
    
    If (bBold) Then eFlags = eFlags Or FF_BOLD
    If (bItalic) Then eFlags = eFlags Or FF_ITALIC
    If (bUnderline) Then eFlags = eFlags Or FF_UNDERLINE
    If (bStrikeOut) Then eFlags = eFlags Or FF_STRIKETHRU
    
    getFontFlags = eFlags
End Function

Private Function createFont(ByRef szName As String, ByVal nSize As Integer, ByVal eFormattingFlags As Integer, _
                            Optional ByVal lFontWeight As Long = -1, Optional ByRef lFontSize As Long = 0, _
                            Optional ByVal lCharSet As Long = ANSI_CHARSET)
    Dim tLF As LOGFONTA, i As Integer, hDCScr As Long, eRet As GpStatus, hFont As Long, lCnt As Long
    
    With tLF
        .lfCharSet = lCharSet
        .lfClipPrecision = CLIP_DEFAULT_PRECIS
        .lfEscapement = 0
        .lfOrientation = 0
        .lfOutPrecision = OUT_DEFAULT_PRECIS
        .lfPitchAndFamily = DEFAULT_PITCH
        .lfQuality = PROOF_QUALITY
        If (Len(szName) > LF_FACESIZE) Then lCnt = LF_FACESIZE Else lCnt = Len(szName)
        '--Convert Font name to ANSI before copying the data
        Call CopyMemory(.lfFaceName(0), ByVal StrPtr(StrConv(szName, vbFromUnicode)), lCnt)

        hDCScr = GetDC(0)
        .lfHeight = -MulDiv(nSize, GetDeviceCaps(hDCScr, LOGPIXELSY), 72)
        lFontSize = (.lfHeight * -1)
        .lfWidth = 0
        
        .lfItalic = IIf((eFormattingFlags And FF_ITALIC), 1, 0)
        .lfStrikeOut = IIf((eFormattingFlags And FF_STRIKETHRU), 1, 0)
        .lfUnderline = IIf((eFormattingFlags And FF_UNDERLINE), 1, 0)
        
        If (lFontWeight = -1) Then
            .lfWeight = IIf((eFormattingFlags And FF_BOLD), FW_BOLD, FW_NORMAL)
        Else
            .lfWeight = lFontWeight
        End If
    End With
    
    eRet = GdipCreateFontFromLogfontA(hDCScr, tLF, hFont)
    Call ReleaseDC(0, hDCScr)
    Debug.Assert (eRet = Ok)
    createFont = hFont
End Function
















