VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "X3Timer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Declare Function SetTimerAPI Lib "user32.dll" Alias "SetTimer" (ByVal hWnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long) As Long
Private Declare Function KillTimer Lib "user32.dll" (ByVal hWnd As Long, ByVal nIDEvent As Long) As Long

Private m_nTimerID         As Integer
Private m_szTag            As String
Private m_pDisp            As Object
Private m_szProc           As String
Private m_hWnd             As Long
Private m_lTimeOutMillis   As Long

Public Property Get Tag() As String
    Tag = m_szTag
End Property
Public Property Let Tag(ByVal szVal As String)
    m_szTag = szVal
End Property

Public Property Get ID() As Integer
    ID = m_nTimerID
End Property

Public Property Get hWnd() As Long
    hWnd = m_hWnd
End Property

Public Property Get TimeOutMillis() As Long
    TimeOutMillis = m_lTimeOutMillis
End Property

Private Sub Class_Initialize()
    m_nTimerID = 0
End Sub

Private Sub Class_Terminate()
    Call Me.stopTimer
End Sub

Public Function setTimer(ByVal hWnd As Long, ByVal pDisp As Object, ByVal szProcName As String, ByVal lTimeOutMillis As Long, ByVal bInitialCall As Boolean)
    Call Me.stopTimer
    
    m_hWnd = hWnd
    m_szProc = szProcName
    m_lTimeOutMillis = lTimeOutMillis
    m_nTimerID = mTimer.getNextFreeID()
    Set m_pDisp = pDisp
    
    Call SetTimerAPI(m_hWnd, m_nTimerID, m_lTimeOutMillis, AddressOf mTimer.timerProc)
    Call mTimer.addTimerClient(Me)
    If (bInitialCall) Then Call Me.timerProc
End Function

Public Function stopTimer() As Boolean
    stopTimer = False
    If (m_nTimerID) Then
        Call mTimer.removeTimerClient(Me)
        stopTimer = CBool(KillTimer(m_hWnd, m_nTimerID))
        m_nTimerID = 0
    End If
End Function

Public Function timerProc()
    If (m_nTimerID) Then
        Call Interaction.CallByName(m_pDisp, m_szProc, VbMethod, m_nTimerID)
    End If
End Function


