Attribute VB_Name = "mTimer"
Option Explicit

Private m_colTimerClients As Collection

Public Function addTimerClient(ByRef oTimer As X3Timer)
    Call m_colTimerClients.Add(oTimer, makeID(oTimer.ID))
End Function

Public Function removeTimerClient(ByRef oTimer As X3Timer)
    Call m_colTimerClients.Remove(oTimer.ID)
End Function

Public Sub timerProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal idEvent As Long, ByVal dwTime As Long)
    On Error GoTo EH
    Dim oTimer As X3Timer
    
    '--Find the timer in the collection via its key
    Set oTimer = m_colTimerClients.Item(makeID(idEvent))
    Call oTimer.timerProc
    Exit Sub
EH:
    Debug.Print "TimerProc Error"
End Sub

Public Function getNextFreeID() As Integer
    On Error Resume Next
    Dim nID As Integer, i As Integer
    
    If (m_colTimerClients Is Nothing) Then Set m_colTimerClients = New Collection
    For i = 1 To 32000 Step 1
        Call m_colTimerClients.Item(makeID(i))
        If (Err.Number <> 0) Then
            '--Key not found, so this ID is free
            nID = i
            Exit For
        End If
    Next i
    
    Call Err.Clear
    getNextFreeID = nID
End Function

Private Function makeID(ByVal nID As Integer) As String
    makeID = "ID=" + CStr(nID)
End Function
































