VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "X3BIcon"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Declare Function GdipSaveImageToStream Lib "GdiPlus.dll" (ByVal mImage As Long, ByVal mStream As Long, ByRef mClsidEncoder As Long, ByRef mEncoderParams As Any) As GpStatus
Private Declare Function GetDIBits Lib "gdi32.dll" (ByVal aHDC As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, ByRef lpBits As Any, ByRef lpBI As BITMAPINFOHEADER, ByVal wUsage As Long) As Long

Private Declare Function GdipSetImageAttributesRemapTable Lib "GdiPlus.dll" (ByVal mImageattr As Long, ByVal mType As ColorAdjustType, ByVal mEnableFlag As Long, ByVal mMapSize As Long, ByRef mMap As ColorMap) As GpStatus
Private Enum ColorAdjustType
    ColorAdjustTypeDefault = &H0
    ColorAdjustTypeBitmap = &H1
    ColorAdjustTypeBrush = &H2
    ColorAdjustTypePen = &H3
    ColorAdjustTypeText = &H4
    ColorAdjustTypeCount = &H5
    ColorAdjustTypeAny = &H6
End Enum

Private Type ColorMap
    oldColor As Long
    newColor As Long
End Type

Private Declare Function GdipCreateImageAttributes Lib "GdiPlus.dll" (ByRef mImageattr As Long) As GpStatus
Private Declare Function GdipDisposeImageAttributes Lib "GdiPlus.dll" (ByVal mImageattr As Long) As GpStatus
Private Declare Function GdipSetImageAttributesColorMatrix Lib "GdiPlus.dll" (ByVal mImageattr As Long, ByVal mType As ColorAdjustType, ByVal mEnableFlag As Long, ByRef mGpColorMatrix As ColorMatrix, ByRef mGrayMatrix As ColorMatrix, ByVal mFlags As ColorMatrixFlags) As GpStatus
Private Declare Function GdipDrawImageRectRectI Lib "GdiPlus.dll" (ByVal mGraphics As Long, ByVal mImage As Long, ByVal mDstx As Long, ByVal mDsty As Long, ByVal mDstwidth As Long, ByVal mDstheight As Long, ByVal mSrcx As Long, ByVal mSrcy As Long, ByVal mSrcwidth As Long, ByVal mSrcheight As Long, ByVal mSrcUnit As GpUnit, ByRef mImageAttributes As Long, ByRef mcallback As Long, ByRef mcallbackData As Long) As GpStatus
Private Declare Function GdipDisposeImage Lib "GdiPlus.dll" (ByVal mImage As Long) As GpStatus
Private Declare Function GdipLoadImageFromStream Lib "GdiPlus.dll" (ByVal mStream As Long, ByRef mImage As Long) As GpStatus
Private Declare Function GdipCloneBitmapArea Lib "GdiPlus.dll" (ByVal mX As Single, ByVal mY As Single, ByVal mWidth As Single, ByVal mHeight As Single, ByVal mPixelFormat As Long, ByVal mSrcBitmap As Long, ByRef mDstBitmap As Long) As GpStatus
Private Declare Function GdipImageRotateFlip Lib "GdiPlus.dll" (ByVal mImage As Long, ByRef mRfType As RotateFlipType) As GpStatus
Private Declare Function GdipLoadImageFromFile Lib "GdiPlus.dll" (ByVal mFilename As Long, ByRef mImage As Long) As GpStatus
Private Declare Function GdipGetImageDimension Lib "GdiPlus.dll" (ByVal mImage As Long, ByRef mWidth As Single, ByRef mHeight As Single) As GpStatus
Private Declare Function GdipCreateHBITMAPFromBitmap Lib "GdiPlus.dll" (ByVal mBitmap As Long, ByRef mHbmReturn As Long, ByVal mBackground As Long) As GpStatus
Private Declare Function GdipGetImageThumbnail Lib "GdiPlus.dll" (ByVal mImage As Long, ByVal mThumbWidth As Long, ByVal mThumbHeight As Long, ByRef mThumbImage As Long, ByRef mcallback As Any, ByRef mcallbackData As Any) As GpStatus
Private Declare Function GdipGetImagePixelFormat Lib "GdiPlus.dll" (ByVal mImage As Long, ByRef mFormat As Long) As GpStatus

Private Type BITMAPINFOHEADER
    biSize          As Long
    biWidth         As Long
    biHeight        As Long
    biPlanes        As Integer
    biBitCount      As Integer
    biCompression   As Long
    biSizeImage     As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed       As Long
    biClrImportant  As Long
End Type

Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (ByRef Destination As Any, ByRef Source As Any, ByVal Length As Long)
Private Declare Function DeleteObject Lib "gdi32.dll" (ByVal hObject As Long) As Long
Private Declare Function CreateDIBSection Lib "gdi32.dll" (ByVal hdc As Long, ByRef pBitmapInfoHdr As BITMAPINFOHEADER, ByVal un As Long, ByVal lplpVoid As Long, ByVal handle As Long, ByVal dw As Long) As Long
Private Declare Function GdipCreateBitmapFromScan0 Lib "GdiPlus.dll" (ByVal mWidth As Long, ByVal mHeight As Long, ByVal mStride As Long, ByVal mPixelFormat As Long, ByVal mScan0 As Long, ByRef mBitmap As Long) As GpStatus

Private Declare Function GlobalAlloc Lib "kernel32.dll" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
Private Declare Function GlobalLock Lib "kernel32.dll" (ByVal hMem As Long) As Long
Private Declare Function GlobalUnlock Lib "kernel32.dll" (ByVal hMem As Long) As Long
Private Declare Function GlobalFree Lib "kernel32.dll" (ByVal hMem As Long) As Long
Private Const GMEM_ZEROINIT As Long = &H40
Private Const GMEM_MOVEABLE As Long = &H2
Private Const S_OK          As Long = &H0

Private Declare Function CreateCompatibleDC Lib "gdi32.dll" (ByVal hdc As Long) As Long
Private Declare Function SelectObject Lib "gdi32.dll" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteDC Lib "gdi32.dll" (ByVal hdc As Long) As Long

Private Declare Function GetDC Lib "user32.dll" (ByVal hWnd As Long) As Long
Private Declare Function ReleaseDC Lib "user32.dll" (ByVal hWnd As Long, ByVal hdc As Long) As Long
Private Declare Function CreateCompatibleBitmap Lib "gdi32.dll" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long

Private Enum GpStatus
    Ok = &H0
End Enum

Private Enum GpUnit
    UnitPixel = &H2
End Enum

Private Type ColorMatrix
    m(0 To 4, 0 To 4) As Single
End Type

Private Enum ColorMatrixFlags
    ColorMatrixFlagsDefault = &H0
End Enum

Private Enum RotateFlipType
    RotateNoneFlipY = &H6
End Enum

Private Type IconHeader
    nReserved As Integer
    nType     As Integer
    nImgCnt   As Integer
End Type
    
Private Type IconDirectory
    bWidth        As Byte
    bHeight       As Byte
    bColorCnt     As Byte
    bReserved     As Byte
    nColPlanes    As Integer
    nBpp          As Integer
    lBmpDataSize  As Long
    lBmpAddOffset As Long
End Type

Private Const IMAGE_ICON           As Long = 1
Private Const IMAGE_CURSOR         As Long = 2
Private Const PixelFormat32bppARGB As Long = &H26200A
Private Const PixelFormat24bppRGB  As Long = &H21808
Private Const DIB_RGB_COLORS       As Long = 0
Private Const BI_RGB               As Long = 0&

Private Type RECTL
    Left   As Long
    Top    As Long
    Width  As Long
    Height As Long
End Type

Private m_nWid                 As Integer
Private m_nHei                 As Integer
Private m_szIconPath           As String
Private m_hIcon                As Long
Private m_bOpacity             As Byte
Private m_sBrightness          As Single
Private m_sRGBIntensityArr(2)  As Single
Private m_rcDestLocation       As RECTL
Private m_szTag                As String

Public Property Get Tag() As String
    Tag = m_szTag
End Property
Public Property Let Tag(ByVal szVal As String)
    m_szTag = szVal
End Property


Private Sub Class_Initialize()
    '--Setup default values
    '--Fully opaque with default brightness and color intensities
    m_bOpacity = 255
    m_sBrightness = 1#
    m_sRGBIntensityArr(0) = 1#
    m_sRGBIntensityArr(1) = 1#
    m_sRGBIntensityArr(2) = 1#
End Sub

Private Sub Class_Terminate()
    '--Cleanup icon if there's any
    Call dispose
End Sub

Public Function hasIcon() As Boolean
    '--Weather or not an icon is loaded
    hasIcon = (m_hIcon <> 0)
End Function

Public Function dispose()
    If (m_hIcon) Then
        Call GdipDisposeImage(m_hIcon)
        m_hIcon = 0
        m_szIconPath = ""
        m_nHei = (-1)
        m_nWid = (-1)
    End If
End Function

'--Valid Arguments:
'--[32bpp BITMAPINFOHEADER][Image Data]
'--File path
'--stream://pStream
'--res://[Type],[Name]
Public Function loadIcon(ByVal vPathOrDibByteArray As Variant, Optional ByVal nIconIndex As Integer = -1) As Boolean
Attribute loadIcon.VB_Description = "[32bppBITMAPINFOHEADER][Image Data] OR FilePath OR stream://pStream OR res://[Type],[Name]"
    Const PNG_FILE_SIG As String = "89504E470D0A1A0A"
    Dim tIconHeader As IconHeader, tDirEntries() As IconDirectory, hFile As Integer, szErr As String, hDIB As Long, bIconData() As Byte, _
        i As Integer, szSig As String, lpMem As Long, hMem As Long, pStream As IStream, tBIH As BITMAPINFOHEADER, hTmpIcon As Long, _
        lpBits As Long, nScanPad As Integer, tTmpIcoHdr As IconHeader, tTmpDirEntry As IconDirectory, sW As Single, sH As Single, _
        nBestIndx As Integer, nHighestBPP As Integer, lLargestArea As Long, lArea As Long, szPath As String, eRet As GpStatus, _
        szParamArr() As String, hIcon As Long
    
    '--Delete any previous icon
    Call dispose
    '--Check for DIB Byte array. Only 32 bpp is supported.
    If (IsArray(vPathOrDibByteArray)) Then
        '--Variant to Byte Array
        bIconData = vPathOrDibByteArray
        Call CopyMemory(tBIH, bIconData(0), 40)
        eRet = GdipCreateBitmapFromScan0(tBIH.biWidth, tBIH.biHeight, (tBIH.biWidth * 4&), _
                                         EPixelFormat.PixelFormat32bppARGB, VarPtr(bIconData(40)), hIcon)
        If (eRet <> Ok) Then szErr = "Invalid byte array"
    Else
        szPath = Trim(CStr(vPathOrDibByteArray))
        If (szPath = "") Then
            loadIcon = False
            Exit Function
        End If
        
        szErr = vbNullString
        '--Icon files are a special case. GDIPlus doesnt load 32bpp Icons properly.
        '--(Alpha channel gets screwed) and icons now contain PNG data as well
        If (Right(szPath, 4) = ".ico") Then
            hFile = FreeFile()
            Open szPath For Binary Access Read Lock Write As hFile
                '--Grab the Icon File header and check it for validity
                Get hFile, 1, tIconHeader
                If ((tIconHeader.nReserved = 0) And ((tIconHeader.nType = IMAGE_ICON) Or (tIconHeader.nType = IMAGE_CURSOR)) And (tIconHeader.nImgCnt > 0)) Then
                    If (nIconIndex < tIconHeader.nImgCnt) Then
                        ReDim tDirEntries(tIconHeader.nImgCnt - 1)
                        Get hFile, , tDirEntries
                        
                        '--Find best quality icon. Bit-depth is of most importance
                        If (nIconIndex = -1) Then
                            nHighestBPP = (-1)
                            For i = 0 To UBound(tDirEntries) Step 1
                                With tDirEntries(i)
                                    If (.nBpp >= nHighestBPP) Then
                                        If (.nBpp > nHighestBPP) Then
                                            '--Reset icon area to -1 so the first icon of bit-depth nBpp will be used
                                            lLargestArea = (-1)
                                            nHighestBPP = .nBpp
                                        End If
                                        '--If Width/Height == 0, Width/Height is 256. used primarily for PNGs
                                        lArea = CLng(IIf((.bWidth = 0), 256, .bWidth)) * CLng(IIf((.bHeight = 0), 256, .bHeight))
                                        If (lArea > lLargestArea) Then
                                            nBestIndx = i
                                            lLargestArea = lArea
                                        End If
                                    End If
                                End With
                            Next i
                            nIconIndex = nBestIndx
                        End If
                        
                        With tDirEntries(nIconIndex)
                            sW = IIf((.bWidth = 0), 256, .bWidth)
                            sH = IIf((.bHeight = 0), 256, .bHeight)
                            
                            '--Resize array to hold icon data
                            ReDim bIconData(.lBmpDataSize - 1)
                            Get hFile, (.lBmpAddOffset + 1), bIconData
                            
                            '--Build 8 byte hex signature to use in PNG check
                            For i = 0 To 7 Step 1
                                szSig = szSig + Right("0" + Hex(bIconData(i)), 2)
                            Next i
                            
                            '--Check for PNG image
                            If (UCase(szSig) = PNG_FILE_SIG) Then
                                '--Create Global memory and copy the PNG data into it
                                hMem = GlobalAlloc(GMEM_MOVEABLE Or GMEM_ZEROINIT, .lBmpDataSize)
                                If (hMem) Then
                                    lpMem = GlobalLock(hMem)
                                    If (lpMem) Then
                                        Call CopyMemory(ByVal lpMem, bIconData(0), .lBmpDataSize)
                                        Call GlobalUnlock(hMem)
                                        '--Wrap an IStream around the global memory and try to load an image from it
                                        Set pStream = CreateStreamOnHGlobal(hMem, 1)
                                        If (Not pStream Is Nothing) Then
                                            Call GdipLoadImageFromStream(ObjPtr(pStream), hIcon)
                                        End If
                                    End If
                                    '--If the image load failed, release the memory
                                    If (hIcon = 0) Then Call GlobalFree(hMem)
                                End If
                            ElseIf (.nBpp = 32) Then
                                '--Create 32bpp BitmapInfoHeader
                                With tBIH
                                    .biBitCount = 32
                                    .biCompression = BI_RGB
                                    .biHeight = sH
                                    .biPlanes = 1
                                    .biSize = Len(tBIH)
                                    .biSizeImage = (CLng(m_nWid) * CLng(m_nHei) * 4&)
                                    .biWidth = sW
                                End With
                                
                                '--Create a DIBSection for the 32bpp icon data and copy the icon data to lpBits
                                hDIB = CreateDIBSection(0, tBIH, DIB_RGB_COLORS, VarPtr(lpBits), 0, 0)
                                If (hDIB) Then
                                    Call CopyMemory(ByVal lpBits, bIconData(40), tBIH.biSizeImage)
                                    If (GdipCreateBitmapFromScan0(m_nWid, m_nHei, (m_nWid * 4), PixelFormat32bppARGB, lpBits, hTmpIcon) = Ok) Then
                                        '--Clone the image so we can delete the src image, i.e. the DIB
                                        Call GdipCloneBitmapArea(0, 0, m_nWid, m_nHei, PixelFormat32bppARGB, hTmpIcon, hIcon)
                                        '--DIBs are bottom up, so flip it vertically
                                        If (hIcon) Then Call GdipImageRotateFlip(m_hIcon, ByVal RotateNoneFlipY)
                                        Call GdipDisposeImage(hTmpIcon)
                                    End If
                                    '--Delete the DIB since we cloned it (hopefully...)
                                    Call DeleteObject(hDIB)
                                End If
                            Else
                                '--Pass other icon data to GDIPlus directly. We already checked for PNG and 32bpp icons
                                '--Create an icon file in memory
                                tTmpIcoHdr.nImgCnt = 1
                                tTmpIcoHdr.nReserved = 0
                                tTmpIcoHdr.nType = tIconHeader.nType
                                
                                '--Copy Current IconDirEntry to a temp IconDirEntry struct and adjust the bitmap data offset
                                tTmpDirEntry = tDirEntries(nIconIndex)
                                tTmpDirEntry.lBmpAddOffset = Len(tTmpIcoHdr) + Len(tTmpDirEntry)
                                
                                '--Allocate global memory for the Icon file and copy the contents into it
                                hMem = GlobalAlloc(GMEM_MOVEABLE Or GMEM_ZEROINIT, Len(tTmpIcoHdr) + Len(tTmpDirEntry) + tTmpDirEntry.lBmpDataSize)
                                If (hMem) Then
                                    lpMem = GlobalLock(hMem)
                                    If (lpMem) Then
                                        '--Header...
                                        Call CopyMemory(ByVal (lpMem + 0), tTmpIcoHdr, Len(tTmpIcoHdr))
                                        '--Single Dir Entry...
                                        Call CopyMemory(ByVal (lpMem + Len(tTmpIcoHdr)), tTmpDirEntry, Len(tTmpDirEntry))
                                        '--Icon data...
                                        Call CopyMemory(ByVal (lpMem + Len(tTmpIcoHdr) + Len(tTmpDirEntry)), bIconData(0), tTmpDirEntry.lBmpDataSize)
                                        Call GlobalUnlock(hMem)
                                        
                                        '--Load via stream...
                                        Set pStream = CreateStreamOnHGlobal(hMem, 1)
                                        If (Not pStream Is Nothing) Then
                                            Call GdipLoadImageFromStream(ObjPtr(pStream), m_hIcon)
                                        End If
                                    End If
                                    '--Fre memory if icon failed to load
                                    If (hIcon = 0) Then Call GlobalFree(hMem)
                                End If
                            End If
                        End With
                    Else
                        szErr = "Invalid icon index"
                    End If
                Else
                    szErr = "Invalid file header"
                End If
            Close hFile
        ElseIf (InStr(1, szPath, "stream://", vbTextCompare) <> 0) Then
            '--Load icon from IStream...
            '--Ex: stream://52854765
            If (GdipLoadImageFromStream(CLng(Mid(szPath, 10)), hIcon) <> Ok) Then
                szErr = "Invalid stream"
            End If
        ElseIf (InStr(1, szPath, "res://", vbTextCompare) <> 0) Then
            '--Load icon from resource...
            '--Ex: res://BUTTONS,Aero1
            szParamArr = Split(Mid(szPath, 7), ",")
            szErr = "Invalid resource"
            If (mUtil.resource2ByteArray(szParamArr(0), szParamArr(1), bIconData)) Then
                Set pStream = mUtil.byteArray2Stream(bIconData)
                szErr = "Out of memory"
                If (Not pStream Is Nothing) Then
                    If (GdipLoadImageFromStream(ObjPtr(pStream), hIcon) = Ok) Then szErr = vbNullString
                End If
            End If
        Else
            '--Load from file...
            If (GdipLoadImageFromFile(StrPtr(szPath), hIcon) <> Ok) Then
                szErr = "Invalid src/out of memory"
            End If
        End If
    End If
    
    '--Check for error
    If (szErr <> vbNullString) Then
        Call Err.Raise(vbObjectError + 1, "loadIcon()", szErr)
        Exit Function
    End If
    
    If (hIcon) Then
        Call GdipGetImageDimension(hIcon, sW, sH)
        m_hIcon = hIcon
        m_szIconPath = szPath
        m_nWid = CInt(sW)
        m_nHei = CInt(sH)
        With m_rcDestLocation
            .Left = 0
            .Top = 0
            .Width = m_nWid
            .Height = m_nHei
        End With
    End If
    
    loadIcon = (hIcon <> 0)
End Function

Public Function setIconImage(ByVal hImg As Long)
    Dim sW As Single, sH As Single
    
    Call dispose
    If (hImg) Then
        Call GdipGetImageDimension(hImg, sW, sH)
        m_szIconPath = vbNullString
        m_hIcon = hImg
        m_nWid = sW
        m_nHei = sH
        m_rcDestLocation.Width = m_nWid
        m_rcDestLocation.Height = m_nHei
    End If
End Function

Public Function setOpacity(ByVal bOpacity As Byte)
    m_bOpacity = bOpacity
End Function

Public Function setBrightness(ByVal sBrightness As Single)
    m_sBrightness = sBrightness
End Function

Public Function setRGBIntensity(Optional ByRef sR As Single = -1, Optional ByRef sG As Single = -1, Optional ByRef sB As Single = -1)
    If (sR >= 0) Then m_sRGBIntensityArr(0) = sR
    If (sG >= 0) Then m_sRGBIntensityArr(1) = sG
    If (sB >= 0) Then m_sRGBIntensityArr(2) = sB
End Function

Public Function getRGBIntensity(Optional ByRef sR As Single = -1, Optional ByRef sG As Single = -1, Optional ByRef sB As Single = -1)
    sR = m_sRGBIntensityArr(0)
    sG = m_sRGBIntensityArr(1)
    sB = m_sRGBIntensityArr(2)
End Function

Public Function setDestinationXYWH(Optional ByVal lX As Long = -1, Optional ByVal lY As Long = -1, Optional ByVal lW As Long = -1, Optional ByVal lH As Long = -1)
    With m_rcDestLocation
        If (lX <> -1) Then .Left = lX
        If (lY <> -1) Then .Top = lY
        If (lW <> -1) Then .Width = lW
        If (lH <> -1) Then .Height = lH
    End With
End Function

Public Property Get DestX() As Long
    DestX = m_rcDestLocation.Left
End Property
Public Property Let DestX(ByVal lX As Long)
    m_rcDestLocation.Left = lX
End Property

Public Property Get DestY() As Long
    DestY = m_rcDestLocation.Top
End Property
Public Property Let DestY(ByVal lY As Long)
    m_rcDestLocation.Top = lY
End Property

Public Property Get DestW() As Long
    DestW = m_rcDestLocation.Width
End Property
Public Property Let DestW(ByVal lW As Long)
    m_rcDestLocation.Width = lW
End Property

Public Property Get DestH() As Long
    DestH = m_rcDestLocation.Height
End Property
Public Property Let DestH(ByVal lH As Long)
    m_rcDestLocation.Height = lH
End Property

Public Property Get Brightness() As Single
    Brightness = m_sBrightness
End Property

Public Property Get Opacity() As Byte
    Opacity = m_bOpacity
End Property
Public Property Let Opacity(ByVal bVal As Byte)
    m_bOpacity = bVal
End Property

Public Property Get Width() As Integer
    Width = m_nWid
End Property

Public Property Get Height() As Integer
    Height = m_nHei
End Property

Public Property Get IconFileName() As String
    IconFileName = m_szIconPath
End Property

Public Function drawIcon(ByVal hGraphics As Long) As Boolean
    Dim bRet As Boolean, tColMatrix As ColorMatrix, tGreyMatrix As ColorMatrix, hImgAttr As Long, eRet As GpStatus, i As Integer
    
    bRet = False
    If (m_hIcon) Then
        '--Create 5x5 Color matrix
        '[ R, 0, 0, 0, 0]
        '[ 0, G, 0, 0, 0]
        '[ 0, 0, B, 0, 0]
        '[ 0, 0, 0, A, 0]
        '[ 1, 1, 1, 1, 1]
        '(5,5) must always be 1
        'When manipulation color intensities, setting (5,1)-(5,4) seems to work better
        With tColMatrix
            .m(0, 0) = (m_sBrightness * m_sRGBIntensityArr(0))
            .m(1, 1) = (m_sBrightness * m_sRGBIntensityArr(1))
            .m(2, 2) = (m_sBrightness * m_sRGBIntensityArr(2))
            .m(3, 3) = (m_bOpacity / 255)
            .m(4, 4) = 1
            
            .m(4, 0) = 1
            .m(4, 1) = 1
            .m(4, 2) = 1
            .m(4, 3) = 0
        End With
        
        eRet = GdipCreateImageAttributes(hImgAttr)
        eRet = GdipSetImageAttributesColorMatrix(hImgAttr, ColorAdjustTypeBitmap, 1, tColMatrix, tGreyMatrix, ColorMatrixFlagsDefault)
        bRet = (GdipDrawImageRectRectI(hGraphics, m_hIcon, DestX, DestY, DestW, DestH, 0, 0, m_nWid, m_nHei, UnitPixel, ByVal hImgAttr, ByVal 0, ByVal 0) = Ok)
        Call GdipDisposeImageAttributes(hImgAttr)
    End If
    drawIcon = bRet
End Function

Public Function getHBMP(ByVal lW As Long, ByVal lH As Long, Optional ByVal lCol32BG As Long = 0) As Long
    Dim hBmp As Long, hDCMem As Long, hBmpPrev As Long, hGraphics As Long
    
    If (m_hIcon) Then
        '--Create a DIB section and draw the image onto it
        hBmp = mUtil.createDIB(lW, lH, 32, 0)
        hDCMem = mUtil.CreateCompatibleDC(0)
        hBmpPrev = mUtil.SelectObject(hDCMem, hBmp)
        hGraphics = mUtil.getGraphicsContext(hDCMem)
        Call mUtil.setAAGraphicsSmoothingMode(hGraphics)
        '--Fill with a BG col if necessary
        If (lCol32BG) Then
            Call mUtil.fillRectGDIP(hGraphics, lCol32BG, 0, 0, lW, lH)
        End If
        '--Set the destination props then draw the icon
        Call setDestinationXYWH(0, 0, lW, lH)
        Call drawIcon(hGraphics)
        Call mUtil.deleteGraphicsContext(hGraphics)
        Call mUtil.SelectObject(hDCMem, hBmpPrev)
        Call mUtil.DeleteDC(hDCMem)
    End If

    getHBMP = hBmp
End Function

Public Function deleteBMP(ByVal hBmp As Long) As Boolean
    '--Convinience function....
    deleteBMP = (mUtil.DeleteObject(hBmp) <> 0)
End Function

'Public Function resize(ByVal lNewW As Long, ByVal lNewH As Long, Optional ByVal ePxFrmt As EPixelFormat = 0) As Boolean
Public Function resize(ByVal lNewW As Long, ByVal lNewH As Long, Optional ByVal ePxFrmt As Long = 0) As Boolean
    Dim hImgResized As Long, sW As Single, sH As Single, lPxFormat As Long, hGraphics As Long

    If (m_hIcon) Then
        '--Resize image by creating a blank image then draw the resized icon onto it
        If (ePxFrmt = 0) Then Call GdipGetImagePixelFormat(m_hIcon, lPxFormat) Else lPxFormat = ePxFrmt
        hImgResized = mUtil.createImage(lNewW, lNewH, lPxFormat)
        If (hImgResized) Then
            hGraphics = mUtil.getImageGraphicsContext(hImgResized)
            '--AA smoothing mode
            Call mUtil.setAAGraphicsSmoothingMode(hGraphics)
            '--Set destination W and H to that of lNewW and lNewH
            Call setDestinationXYWH(0, 0, lNewW, lNewH)
            Call drawIcon(hGraphics)
            Call mUtil.deleteGraphicsContext(hGraphics)
            
            '--Dispose of old image and set new image
            Call setIconImage(hImgResized)
        End If
    End If
    resize = (hImgResized <> 0)
End Function

Public Function duplicate() As X3BIcon
    Dim oIcon As X3BIcon, hImgDuplicate As Long, lPxFormat As Long

    If (m_hIcon) Then
        '--Duplicate the this Icon by cloning it
        Call GdipGetImagePixelFormat(m_hIcon, lPxFormat)
        If (GdipCloneBitmapArea(0, 0, m_nWid, m_nHei, lPxFormat, m_hIcon, hImgDuplicate) = Ok) Then
            Set oIcon = New X3BIcon
            Call oIcon.setIconImage(hImgDuplicate)
        End If
    End If
    Set duplicate = oIcon
End Function

Public Function getIconAs32bppDIBByteArray(ByRef bDataArr() As Byte) As Boolean
    Dim bOK As Boolean, eRet As GpStatus, tBIH As BITMAPINFOHEADER, hBmp As Long, hDCScr As Long

    bOK = False
    If (m_hIcon) Then
        '--Get icon data in Icon DIB format
        '--First 40 bytes: BitmapInfoHeader, the rest is the actual image data
        With tBIH
            .biBitCount = 32
            .biSize = Len(tBIH)
            .biCompression = BI_RGB
            .biPlanes = 1
            .biWidth = m_nWid
            .biHeight = m_nHei
            .biSizeImage = (CLng(m_nWid) * CLng(m_nHei) * 4&)
        End With
        '--Create a suitable sized array
        ReDim bDataArr((40 + tBIH.biSizeImage) - 1)
        Call mUtil.CopyMemory(bDataArr(0), tBIH, Len(tBIH))
        
        '--Flip image vertically to conform to DIB standards
        Call GdipImageRotateFlip(m_hIcon, ByVal RotateNoneFlipY)
        '--Convert image to HBITMAP so we can iuse GetDIBits(...)
        Call GdipCreateHBITMAPFromBitmap(m_hIcon, hBmp, &HFFFFFFFF)
        '--Undo flip
        Call GdipImageRotateFlip(m_hIcon, ByVal RotateNoneFlipY)
        
        '--Get the image data with a bit-depth of 32bpp
        '--GetDIBits return the number of scans (height) copied to the buffer
        hDCScr = GetDC(0)
        bOK = (GetDIBits(hDCScr, hBmp, 0, m_nHei, bDataArr(40), tBIH, DIB_RGB_COLORS) = m_nHei)
        Call ReleaseDC(0, hDCScr)
        '--Delete hBmp, we no longer need it as we [should] have the actual image data
        If (hBmp) Then Call mUtil.DeleteObject(hBmp)
    End If

    getIconAs32bppDIBByteArray = bOK
End Function

Public Function getIconAsPNGByteStream(ByRef bPNGDataArr() As Byte) As Boolean
    Dim pStream As IStream, lEncCLSID(3) As Long, lSize As Long, tStreamData As STATSTG
    
    getIconAsPNGByteStream = False
    If (m_hIcon) Then
        '--Save image as PNG byte stream
        Set pStream = CreateStreamOnHGlobal(0, 1)
        If (Not pStream Is Nothing) Then
            '--Get the CLSID of the PNG Image encoder and use it to save image to IStream pStream
            If (mUtil.getImageEncoderCLSID("image/png", VarPtr(lEncCLSID(0)))) Then
                If (GdipSaveImageToStream(m_hIcon, ObjPtr(pStream), lEncCLSID(0), ByVal 0) = Ok) Then
                    '--Set the stream RW pointer back to the beginning
                    Call pStream.Seek(0, STREAM_SEEK.STREAM_SEEK_SET)
                    '--Get the size of the stream and create an array of equal size
                    Call pStream.Stat(tStreamData, STATFLAG_DEFAULT)
                    tStreamData.cbSize = (tStreamData.cbSize * 10000)
                    ReDim bPNGDataArr(tStreamData.cbSize - 1)
                    '--Copy stream sontents into byte array
                    Call pStream.Read(bPNGDataArr(0), tStreamData.cbSize)
                    getIconAsPNGByteStream = True
                End If
            End If
            '--pStream->Release();
            Set pStream = Nothing
        End If
    End If
End Function











