VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cUtil"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'--Wrapper class for mUtil

Option Explicit

Public Function initializeGDIPlus() As Boolean
    initializeGDIPlus = mUtil.initializeGDIPlus()
End Function

Public Function shutdownGDIPlus()
    Call mUtil.shutdownGDIPlus
End Function

Public Function getGDIPlusToken() As Long
    getGDIPlusToken = mUtil.getGDIPlusToken()
End Function

Public Function loadImage(ByRef szPath As String, ByRef hImg As Long, Optional ByRef bFromRes As Boolean = False) As Boolean
    loadImage = mUtil.loadImage(szPath, hImg, bFromRes)
End Function

Public Function deleteImage(ByVal hImg As Long) As Boolean
    deleteImage = mUtil.deleteImage(hImg)
End Function

Public Function drawRectFrame(ByVal hGraphics As Long, ByVal lX As Long, ByVal lY As Long, ByVal lW As Long, ByVal lH As Long, ByVal lCol32 As Long, ByVal nWid As Integer)
    Call mUtil.drawRectFrame(hGraphics, lX, lY, lW, lH, lCol32, nWid)
End Function

Public Function drawArrow(ByVal hGraphics As Long, ByVal lCenterX As Long, ByVal lCenterY As Long, ByVal lCol32 As Long, ByVal eDir As Integer)
    Call mUtil.drawArrow(hGraphics, lCenterX, lCenterY, lCol32, eDir)
End Function

Public Function getGraphicsContext(ByVal hDCTarget As Long) As Long
    getGraphicsContext = mUtil.getGraphicsContext(hDCTarget)
End Function

Public Function deleteGraphicsContext(ByVal hGraphics As Long)
    Call mUtil.deleteGraphicsContext(hGraphics)
End Function

Public Function setAAGraphicsSmoothingMode(ByVal hGraphics As Long)
    Call mUtil.setAAGraphicsSmoothingMode(hGraphics)
End Function

Public Function getParentBackColor(ByVal ctlParent As Object) As Long
    getParentBackColor = mUtil.getParentBackColor(ctlParent)
End Function

Public Function blitParentBackground(ByVal hWndChild As Long, ByVal hDCDest As Long, ByVal hDCSrc As Long) As Boolean
    blitParentBackground = mUtil.blitParentBackground(hWndChild, hDCDest, hDCSrc)
End Function

Public Function fillRectGDIP(ByVal hGraphics As Long, ByVal lCol32 As Long, ByVal lX As Long, ByVal lY As Long, ByVal lW As Long, ByVal lH As Long, _
                             Optional ByVal lOutlineCol As Long = 0, Optional ByVal lOutlineWid As Long = 1, _
                             Optional ByVal lCol32B As Long = 0, Optional ByVal bHorzGradnt As Boolean = False, _
                             Optional ByVal bRound As Boolean = False, Optional ByVal lArcWid As Long = 6, Optional ByVal lArcHei As Long = 6)
    Call mUtil.fillRectGDIP(hGraphics, lCol32, lX, lY, lW, lH, lOutlineCol, lOutlineWid, lCol32B, bHorzGradnt, bRound, lArcWid, lArcHei)
End Function

Public Function fillRectGDI(ByVal hDCTarget As Long, ByVal lColRef As Long, ByVal lX As Long, ByVal lY As Long, ByVal lW As Long, ByVal lH As Long)
    Call mUtil.fillRectGDI(hDCTarget, lColRef, lX, lY, lW, lH)
End Function

Public Function mouseOverControl(ByRef hWnd As Long) As Boolean
    mouseOverControl = mUtil.mouseOverControl(hWnd)
End Function

Public Function convertColorStructure(ByVal lCol As Long, ByVal eCMode As Long) As Long
    convertColorStructure = mUtil.convertColorStructure(lCol, eCMode)
End Function

Public Function getRelativeCursorPosition(ByRef lX As Long, ByRef lY As Long, ByVal hWnd As Long)
    Call mUtil.getRelativeCursorPosition(lX, lY, hWnd)
End Function

Public Function splitDWORD(ByRef dwVal As Long, ByRef nLW As Integer, ByRef nHW As Integer)
    Call mUtil.splitDWORD(dwVal, nLW, nHW)
End Function

Public Function splitDWORDEx(ByRef dwVal As Long, ByRef bLWLB As Byte, ByRef bLWHB As Byte, ByRef bHWLB As Byte, ByRef bHWHB As Byte)
    Call mUtil.splitDWORDEx(dwVal, bLWLB, bLWHB, bHWLB, bHWHB)
End Function

Public Function makeDWORD(ByRef dwVal As Long, ByRef nLW As Integer, ByRef nHW As Integer)
    Call mUtil.makeDWORD(dwVal, nLW, nHW)
End Function

Public Function makeForegroundWindow(ByVal hWndNewFG As Long)
    Call mUtil.makeForegroundWindow(hWndNewFG)
End Function

Public Function getWindowDimensions(ByVal hWnd As Long, ByRef lX As Long, ByRef lY As Long, ByRef lW As Long, ByRef lH As Long)
    Call mUtil.getWindowDimensions(hWnd, lX, lY, lW, lH)
End Function

Public Function getTopLevelParent(ByVal hWnd As Long) As Long
    getTopLevelParent = mUtil.getTopLevelParent(hWnd)
End Function

Public Function translateOLEColor(ByVal lCol As Long) As Long
    translateOLEColor = mUtil.translateOLEColor(lCol)
End Function

Public Function getDWORDPaddedSize(ByVal lW As Long) As Long
    getDWORDPaddedSize = mUtil.getDWORDPaddedSize(lW)
End Function

Public Function createDIB(ByVal lW As Long, ByVal lH As Long, ByVal nBpp As Integer, ByRef lpBits As Long) As Long
    createDIB = mUtil.createDIB(lW, lH, nBpp, lpBits)
End Function

Public Function createImage(ByVal lW As Long, ByVal lH As Long, ByVal ePxFrmt As Long) As Long
    createImage = mUtil.createImage(lW, lH, ePxFrmt)
End Function

Public Function createImageFromDIB(ByVal hDIB As Long) As Long
    createImageFromDIB = mUtil.createImageFromDIB(hDIB)
End Function

Public Function drawBmp(ByVal hBmp As Long, ByVal hDCDest As Long, ByVal lX As Long, ByVal lY As Long, Optional ByVal lW As Long = -1, _
                        Optional ByVal lH As Long = -1) As Long
    drawBmp = mUtil.drawBmp(hBmp, hDCDest, lX, lY, lW, lH)
End Function

Public Function createStdPicFromDC(ByVal hDCSrc As Long, Optional ByVal lX As Long = -1, Optional ByVal lY As Long = -1, _
                                   Optional ByVal lW As Long = -1, Optional ByVal lH As Long = -1) As StdPicture
    Set createStdPicFromDC = mUtil.createStdPicFromDC(hDCSrc, lX, lY, lW, lH)
End Function

Public Function getImageGraphicsContext(ByVal hImg As Long) As Long
    getImageGraphicsContext = mUtil.getImageGraphicsContext(hImg)
End Function

Public Function getGraphicsContextDC(ByVal hGraphics As Long) As Long
    getGraphicsContextDC = mUtil.getGraphicsContextDC(hGraphics)
End Function

Public Function releaseGraphicsContextDC(ByVal hGraphics As Long, ByVal hdc As Long)
    Call mUtil.releaseGraphicsContextDC(hGraphics, hdc)
End Function

Public Function getCursorPosition(ByRef lX As Long, ByRef lY As Long, Optional ByVal hWndClient As Long = 0)
    Call mUtil.getCursorPosition(lX, lY, hWndClient)
End Function

Public Function convertBitmapToStdPicture(ByVal hBmp As Long, ByVal lPicType As Long) As StdPicture
    Set convertBitmapToStdPicture = mUtil.convertBitmapToStdPicture(hBmp, lPicType)
End Function

Public Function ARGB(ByVal bA As Byte, ByVal bR As Byte, ByVal bG As Byte, ByVal bB As Byte)
    Call mUtil.ARGB(bA, bR, bG, bB)
End Function

Public Function replaceByte(ByRef dwValue As Long, ByVal nByte As Integer, ByVal bVal As Byte)
    Call mUtil.replaceByte(dwValue, nByte, bVal)
End Function

Public Function getImageEncoderCLSID(ByRef szMimeType As String, ByVal lpBuff As Long) As Boolean
    getImageEncoderCLSID = mUtil.getImageEncoderCLSID(szMimeType, lpBuff)
End Function

Public Function WideStr2BSTR(ByVal lpwStr As Long) As String
    WideStr2BSTR = mUtil.WideStr2BSTR(lpwStr)
End Function

Public Function resource2ByteArray(ByVal szName As String, ByRef szType As String, ByRef bDataArr() As Byte, Optional ByVal hinst As Long = 0) As Boolean
    resource2ByteArray = mUtil.resource2ByteArray(szName, szType, bDataArr, hinst)
End Function

Public Function byteArray2Stream(ByRef bDataArr() As Byte) As IStream
    Set byteArray2Stream = mUtil.byteArray2Stream(bDataArr)
End Function

Public Function stream2ByteArray(ByVal pStream As IStream, ByRef bDataArr() As Byte) As Boolean
    stream2ByteArray = mUtil.stream2ByteArray(pStream, bDataArr)
End Function

Public Function getHANDCursor() As StdPicture
    Set getHANDCursor = mUtil.getHANDCursor()
End Function



